const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const genres = sequelize.define(
    'genres',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  genres.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














    db.genres.hasMany(db.releases, {
      as: 'releases_primary_genre',
      foreignKey: {
          name: 'primary_genreId',
      },
      constraints: false,
    });

    db.genres.hasMany(db.releases, {
      as: 'releases_secondary_genre',
      foreignKey: {
          name: 'secondary_genreId',
      },
      constraints: false,
    });


    db.genres.hasMany(db.tracks, {
      as: 'tracks_genre',
      foreignKey: {
          name: 'genreId',
      },
      constraints: false,
    });






























//end loop



    db.genres.belongsTo(db.genres, {
      as: 'parent_genre',
      foreignKey: {
        name: 'parent_genreId',
      },
      constraints: false,
    });

    db.genres.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.genres.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.genres.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return genres;
};


